//$Id: dialog-res.h,v 1.3 2001/03/11 14:14:37 cactus Exp $ -*- c++ -*-

/* Guikachu Copyright (C) 2001 RDI Gerg <cactus@cactus.rulez.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef GUIKATCHU_DIALOG_RES_H
#define GUIKATCHU_DIALOG_RES_H

namespace Guikachu
{
    namespace Resources
    {
	class Dialog;

	enum DialogType
	{
	    DIALOG_INFORMATION,
	    DIALOG_CONFIRMATION,
	    DIALOG_WARNING,
	    DIALOG_ERROR
	};
	    
    }
}

#include "resource.h"
#include "dialog-win.h"

#include <vector>

namespace Guikachu
{
    namespace Resources
    {
	class Dialog: public Resource
	{
	    Guikachu::GUI::DialogWindow *gui;
	public:
	    Dialog (const string& name);
	    virtual ~Dialog ();
	    
	    virtual Type get_type () const { return RESOURCE_DIALOG; };
	    virtual void show_ui ();

	    GUIKACHU_RESOURCE_PROP(title,          string);
	    GUIKACHU_RESOURCE_PROP(text,           string);
	    GUIKACHU_RESOURCE_PROP(dialog_type,    DialogType);
	    GUIKACHU_RESOURCE_PROP(buttons,        vector <string>);
	    GUIKACHU_RESOURCE_PROP(default_button, unsigned int);
	    GUIKACHU_RESOURCE_PROP(help_id,        string);
	    
	private:
	    virtual bool load (xmlDocPtr xml_doc, xmlNodePtr node);
	    virtual void save (xmlNodePtr node) const;
	    virtual void save_rcp (ostream &ostr) const;
	};
    };
};

#endif /* !GUIKATCHU_DIALOG_RES_H */
